//#include"../vector/packed_vector.hpp"
#include"../vector/vector3.hpp"
#include"../vector/matrix4.hpp"
#include"../vector/transform.hpp"

#include<boost/timer.hpp>


#include<algorithm>
#include<functional>
#include <iostream>
#include<iomanip>
#include <cmath>
#include <cstdlib>

int main(){
	
	const int n = 100;
	const std::size_t num = n*n;
	typedef tempest::vector<double,3> Vec;
	typedef tempest::matrix<double,3> Mat;
	//typedef tempest::packed_vector UVec;;
	Vec *va = new Vec[num];
	Mat *ma = new Mat[n];
	//UVec ua[num];
	Vec *vb = new Vec[num];
	std::srand(2123123);
	
	for(int i = 0;i<n;i++){
		for(int j = 0;j<n;j++){
			std::size_t p = i*n+j;
			
			va[p][0]=std::rand();
			va[p][1]=std::rand();
			va[p][2]=std::rand();
		}
	}
		
	
	boost::timer t1;
	
	for(int i = 0;i<n;i++){
		Mat::iterator fi = ma[i].begin();
		Mat::iterator ei = ma[i].end();
		
		
		for(Mat::iterator kk = fi;kk != ei;++kk){
			*kk = std::rand();	
		}
		
		for(int j = 0;j<n;j++){
			std::size_t p = i*n+j;
			
			for(int s = 0;s<6000;s++){
				tempest::transform(ma[i],va[p],vb[p]);
			}
		}
	}
	
	std::cout << t1.elapsed() << std::endl;
	for(int i = 0;i<num;i+=n){
		std::cout <<std::setw(4)<<i<<"::"<< vb[i] << std::endl;
	}
	
	delete[] va;
	delete[] vb;
	delete[] ma;
	
	return 0;
}

