//---------------------------------------------------------------------------
#define _DEBUG 1

#include"../vector/vector.hpp"
#include"../vector/vector4.hpp"
#include"../vector/vector3.hpp"
#include"../vector/vector2.hpp"
#include"../vector/packed_vector.hpp"
#include"../vector/safety_vector.hpp"

#include<iostream>
#include<cstdlib>
#include<cmath>
 
#pragma hdrstop


//


int main(int argc, char* argv[])
{
    std::srand(14118);
    typedef tempest::vector<double,3> VEC;
    std::cout << VEC::c_size << std::endl;

    VEC a[100];
    VEC b[100];
	
	unsigned short us[100];
	unsigned int ui[100];
	
    float err[100];
    float sum=0;
    for(int i = 0;i<100;i++){
        a[i][0] = std::rand();
        a[i][1] = std::rand();
        a[i][2] = std::rand();
    	
    	a[i].normalize();
    }
	
	float xx,yy,zz;	
	
	sum = 0;	
	for(int i = 0;i<100;i++){        
        std::cout << a[i][0] <<","<< a[i][1] <<","<< a[i][2] << ",\t\t";
        //us[i] = tempest::PackVector16(a[i][0],a[i][1],a[i][2]);
		//tempest::UnpackVector16(us[i],&xx,&yy,&zz);
        b[i][0] = xx;
        b[i][1] = yy;
        b[i][2] = zz;
        std::cout << b[i][0] <<","<< b[i][1] <<","<< b[i][2] << "\t\t,";

        VEC e(b[i]-a[i]);
        err[i] = e.length();
		std::cout << err[i] << "\n";
        sum += err[i];
    }
    std::cout <<"16"<< "error: "<<sum<<"\%\n\n\n";
	
	sum = 0;	
	for(int i = 0;i<100;i++){        
        std::cout << a[i][0] <<","<< a[i][1] <<","<< a[i][2] << ",\t\t";
        ui[i] = tempest::PackVector32(a[i][0],a[i][1],a[i][2]);
		tempest::UnpackVector32(ui[i],&xx,&yy,&zz);
        b[i][0] = xx;
        b[i][1] = yy;
        b[i][2] = zz;
        std::cout << b[i][0] <<","<< b[i][1] <<","<< b[i][2] << "\t\t,";

        VEC e(b[i]-a[i]);
        err[i] = e.length();
		std::cout << err[i] << "\n";
        sum += err[i];
    }
    std::cout <<"32" <<"error: "<<sum<<"\%\n\n\n";
	
	sum = 0;	
	for(int i = 0;i<100;i++){        
        std::cout << a[i][0] <<","<< a[i][1] <<","<< a[i][2] << ",\t\t";
        us[i] = tempest::PackVector16x(a[i][0],a[i][1],a[i][2]);
		tempest::UnpackVector16x(us[i],&xx,&yy,&zz);
        b[i][0] = xx;
        b[i][1] = yy;
        b[i][2] = zz;
        std::cout << b[i][0] <<","<< b[i][1] <<","<< b[i][2] << "\t\t,";

        VEC e(b[i]-a[i]);
       	err[i] = e.length();
		std::cout << err[i] << "\n";
        sum += err[i];
    }
    std::cout <<"16x"<< "error: "<<sum<<"\%\n\n\n";
	
	sum = 0;	
	for(int i = 0;i<100;i++){        
        std::cout << a[i][0] <<","<< a[i][1] <<","<< a[i][2] << ",\t\t";
        ui[i] = tempest::PackVector32x(a[i][0],a[i][1],a[i][2]);
		tempest::UnpackVector32x(ui[i],&xx,&yy,&zz);
        b[i][0] = xx;
        b[i][1] = yy;
        b[i][2] = zz;
        std::cout << b[i][0] <<","<< b[i][1] <<","<< b[i][2] << "\t\t,";

        VEC e(b[i]-a[i]);
		err[i] = e.length();
		
		std::cout << err[i] << "\n";
        sum += err[i];
    }
    std::cout <<"32x"<< "error: "<<sum<<"\%\n\n\n";
	
    return 0;
}
//---------------------------------------------------------------------------



